﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Sample42
{ // ポリモフィズム (2)
  class CSHAPRO408
  {
     static void Main(string[] args)
     {
        double h, w, l, r, rarea, sarea, carea;
        Rect rect;
        Square square;
        Circle circle;
        Console.Write("縦: h = ");
        h = double.Parse(Console.ReadLine());
        Console.Write("横: w = ");
        w = double.Parse(Console.ReadLine());
        rect = new Rect(h, w);
        Console.Write("長さ: l = ");
        l = double.Parse(Console.ReadLine());
        square = new Square(l);
        Console.Write("半径 r = ");
        r = double.Parse(Console.ReadLine());
        circle = new Circle(r);
        rarea = rect.area();
        Console.WriteLine("長方形の面積: S = {0}", rarea);
        sarea = square.area();
        Console.WriteLine("正方形の面積: S = {0}", sarea);
        carea = circle.area();
        Console.WriteLine("円の面積: S = {0}", carea);
        Console.ReadKey();
     }
     abstract class Figure
     { // 抽象クラス
         abstract public double area();
     }
     class Rect: Figure
     { // 長方形のクラス
        private double height, width;
        public Rect(double h, double w)
        { // コンストラクタ
            height = h;
            width = w;
        }
        public override double area()
        { // メソッド (面積)
            return (height * width);
        }
     }
     class Square: Figure
     { // 正方形のクラス
        private double length;
        public Square(double l)
        { // コンストラクタ
            length = l;
        }
        public override double area()
        { // メソッド (面積)
            return (length * length);
        }
     }
     class Circle: Figure
     { // 円のクラス
        private double radius;
        public Circle(double r)
        { // コンストラクタ 
            radius = r;
        }
        public override double area()
        { // メソッド (面積)
            return (Math.PI * radius * radius);
        }
     }
  }
}
