﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Sample46
{ // 匿名メソッド
   class CSHAPRO502
   {
      delegate double f(double a, double b);
      static void Main(string[] args)
      {
        f madd = delegate(double a, double b)
        { // 関数 madd の定義 (匿名メソッド)
            double sum;
            sum = a + b;
            return(sum);
        };
        f ladd = (double a, double b) =>
        { // 関数 ladd の定義 (ラムダ式)
            double sum;
            sum = a + b;
            return(sum);
        };
        double x, y;
        Console.WriteLine("実数 x,y を入力してください。");
        Console.Write("x = ");
        x = double.Parse(Console.ReadLine());
        Console.Write("y = ");
        y = double.Parse(Console.ReadLine());
        Console.WriteLine(
           "匿名メソッド: madd(x,y) = {0}", madd(x, y));
        Console.WriteLine(
           "ラムダ式: ladd(x,y) = {0}", ladd(x, y));
        Console.ReadKey();
      }
   }
}
